"use strict";
/*
 * Deepkit Framework
 * Copyright (C) 2021 Deepkit UG, Marc J. Schmidt
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the MIT License.
 *
 * You should have received a copy of the MIT License along with this program.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.SQLiteFilterBuilder = void 0;
const sql_1 = require("@deepkit/sql");
class SQLiteFilterBuilder extends sql_1.SQLFilterBuilder {
    bindValue(value) {
        if (typeof value === 'boolean')
            return value ? 1 : 0;
        return super.bindValue(value);
    }
    regexpComparator(lvalue, value) {
        let regex = value.flags + '::' + value.source; //will be decoded in sqlite-adapter
        return `${lvalue} REGEXP ${this.bindParam(regex)}`;
    }
}
exports.SQLiteFilterBuilder = SQLiteFilterBuilder;
//# sourceMappingURL=sql-filter-builder.sqlite.js.map